var TicksTracer = require('./index.js');

// A flow control package
var Flowa = require('flowa');

// The object to trace
var context = {};

// A dummy flow
var flow = new Flowa({
  type: 'series',
  task1: generateDummyTask(1),
  task2: generateDummyTask(1),
  group1: {
    type: 'parallel',
    task3: generateDummyTask(3),
    task4: generateDummyTask(4)
  },
  task5: generateDummyTask(5)
});

// Start tracing
var ticksTracer = new TicksTracer(context);

// Execute the tasks
flow.run(context).then(function(result) {

  // Get the taken snapshots
  // console.log(ticksTracer.getSnapshots());
  console.log(JSON.stringify(ticksTracer.getSnapshotsDiffs(), null, 2));

  // Stop the tracing
  ticksTracer.stop();

});

// Don't worry about this
function generateDummyTask(id) {
  
  return function(context, callback) {
    context['task' + id] = context['task' + id] ? context['task' + id] + 1 : 1;
    setImmediate(callback);
  };

}
